;#########################################################################
; mbmpview
; Minimal DOS BMP Viewer
; Version 1.0
; Coded by comrade <comrade2k@hotmail.com>
; Web: http://www.comrade64.com/
;      http://comrade.ownz.com/
;      http://comrade.win32asm.com/
;      http://comrade64.cjb.net/
; IRC: #asm, #coders, #win32asm on EFnet
;#########################################################################
.286
.model tiny
locals @@
jumps
;#########################################################################
BITMAPFILEHEADER struc
	bfType		dw	?
	bfSize		dd	?
	bfReserved1	dw	?
	bfReserved2	dw	?
	bfOffBits	dd	?
BITMAPFILEHEADER ends	; 14 bytes
BITMAPINFOHEADER struc
	biSize		dd	?
	biWidth		dd	?
	biHeight	dd	?
	biPlanes	dw	?
	biBitCount	dw	?
	biCompression	dd	?
	biSizeImage	dd	?
	biXPelsPerMeter	dd	?
	biYPelsPerMeter	dd	?
	biClrUsed	dd	?
	biClrImportant	dd	?
BITMAPINFOHEADER ends	; 40 bytes
;#########################################################################
;#########################################################################
CODESEG
.Startup
	mov	si, 0080h
	mov	bl, [si]
	mov	[si+bx+1], bh

	; open file
	mov	ah, 3Dh
	mov	dx, 0081h
	int	21h
	push	ax

	; read headers + palette
	mov	bx, ax
	mov	ah, 3Fh
	mov	dx, OFFSET bmfh
	mov	cx, 436h
	int	21h

	; switch to graphics mode
	mov	ax, 13h
	int	10h

	; initialize palette
	mov	cx, 256
	mov	si, OFFSET palette+(256*4)-1
	std
@@pal:	mov	dx, 3C8h
	mov	al, cl
	dec	al
	out	dx, al
	inc	dx
	lodsb
	mov	bl, 3
@@col:	lodsb
	shr	al, 2
	out	dx, al
	dec	bl
	jnz	short @@col
	loop	short @@pal

	; read data
	pop	bx
	push	0A000h
	pop	ds
	mov	di, 320*200-320
	mov	si, 200
@@line:	mov	ah, 3Fh
	mov	dx, di
	mov	cx, 320
	int	21h
	sub	di, cx
	dec	si
	jnz	short @@line
@@chkk:	; check for key press
	mov	ah, 001h
	int	16h
	jz	short @@chkk
	ret
;#########################################################################
	bmfh	BITMAPFILEHEADER <>
	bmih	BITMAPINFOHEADER <>
	palette	dd	256 dup (?)
;#########################################################################
;#########################################################################
end